/*
 * (C) 1995-2001 Clemson University and Argonne National Laboratory.
 *
 * See COPYING in top-level directory.
 */


static char pvfs_dup_c[] = "$Header: /projects/cvsroot/pvfs/lib/pvfs_dup.c,v 1.4 2001/01/30 23:32:15 pcarns Exp $";

#include <lib.h>

extern fdesc_p pfds[];
extern int errno;

int pvfs_dup(int fd)
{
	int ret;

	if (fd < 0 || fd >= NR_OPEN || (pfds[fd] && pfds[fd]->fs == FS_RESV)) {
		errno = EBADF;
		return(-1);
	}

	if ((ret = dup(fd)) == -1) {
		return(-1);
	}
	else {
		if (pfds[fd] && (pfds[fd]->fs==FS_PVFS || pfds[fd]->fs == FS_PDIR)) {
			pfds[ret] = pfds[fd];
			pfds[fd]->fd.ref++;
		}
		return(ret);
	}
}
