/*
 * (C) 1995-2001 Clemson University and Argonne National Laboratory.
 *
 * See COPYING in top-level directory.
 */


static char pvfs_flock_c[] = "$Header: /projects/cvsroot/pvfs/lib/pvfs_flock.c,v 1.5 2001/01/30 23:32:15 pcarns Exp $";

#include <lib.h>
#include <meta.h>

extern int errno;
extern fdesc_p pfds[];

int pvfs_flock(int fd, int operation)
{
	/* check for badness */
	if (fd < 0 || fd >= NR_OPEN || (pfds[fd] && pfds[fd]->fs == FS_RESV)) {
		errno = EBADF;
		return(-1);
	}  

	/* check for UNIX */
	if (!pfds[fd] || pfds[fd]->fs==FS_UNIX) {
		return flock(fd, operation);
	}

	/* NOT YET IMPLEMENTED! */
	errno = ENOSYS;
	return(-1);
}
